function param = estwarp_condens(frm, tmpl, param, opt)
% function param = estwarp_condens(frm, tmpl, param, opt)
%

%% Copyright (C) Jongwoo Lim and David Ross.
%% All rights reserved.
n = opt.numsample;
sz = opt.tmplsize;

param.param = repmat(affparam2geom(param.est(:)), [1,n]);

%prediction
param.param = param.param + randn(6,n).*repmat(opt.affsig(:),[1,n]); 

wimgs = warpimg(frm, affparam2mat(param.param), sz);

%% use sparse coding 
% SIFT+coding+pooling
% A = SparseRepresentImGPU(wimgs, opt, tmpl.D);  %SIFT+GPU
A = SparseRepresentIm(wimgs, opt, tmpl);       %SIFT

%% use the learned logistic function
P = 1 ./ (1 + exp(-(tmpl.w'*A+tmpl.b)));     % fixed detector
Po =  1 ./ (1 + exp(-(tmpl.wo'*A+tmpl.bo))); % online detector
P_sum = opt.ff * P + (1 - opt.ff)*Po;
param.conf = P_sum;



% %%%%%%%%%%%%%%%%%%%find the tracking result%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[maxprob,maxidx] = max(param.conf);
param.est = affparam2mat(param.param(:,maxidx)); %
param.obser = A(:,maxidx);
param.conf = maxprob;




