
function x = gpu_ls_Coordinate_Descent(B,b,x0,alpha,idx,lambda,rho,c,lsiter,maxiter)

x = x0;
for i = 1:maxiter
    g = B * x + b;
    d = g - x;
    dx = (-d-lambda) .* ( d < -lambda ) + (-d+lambda) .* ( d > lambda );
    p = -x + dx;
    % line search
    % ---------- Initialize ----------
    pBp = 0.5*sum((B'*p).*p); gp = sum(g.*p);
    h = lambda*sum(abs(x));
    % ---------- Begin backtracking ----------
    for j = 1:lsiter
        update = rho .* idx + (~idx);
        alpha = update .* alpha;
        xnew = x + repmat( alpha, size(x,1), 1 ) .* p;
        hnew = pBp .* alpha .* alpha + gp .* alpha + lambda * sum(abs(xnew)); % current function value
        idx = (hnew > h*(1-c));
        if sum(idx) == 0
            break;
        end
        GPUsync;
    end
    x = x + repmat( alpha, size(x,1), 1 ) .* p;
    GPUsync;
end
